"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAssignValueRules = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _getCondition = require("./getCondition");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ASSIGN = 'ASSIGN';
/**
 * Returns event program rules, excluding entity program rules,
 * sorted by priority.
 * @param {Object[]} programRules
 * @param {Object[]} programRuleVariables
 * @returns {Object[]}
 */

var getAssignValueRules = function getAssignValueRules(programRules, programRuleVariables) {
  return programRules.filter(function (r) {
    return r.programRuleActions.find(function (a) {
      return a.dataElement && a.programRuleActionType === ASSIGN;
    });
  }).map(function (r) {
    return _objectSpread({}, r, {
      programRuleActions: r.programRuleActions.filter(function (_ref) {
        var programRuleActionType = _ref.programRuleActionType;
        return programRuleActionType === ASSIGN;
      }),
      condition: (0, _getCondition.getCondition)(r.condition, programRuleVariables)
    });
  }).sort(function (a, b) {
    return a.priority > b.priority || !a.priority ? 1 : -1;
  });
};

exports.getAssignValueRules = getAssignValueRules;