"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getCondition = void 0;

/**
 * Replaces '#{x}' with 'values['id of x']
 * @param {string} condition
 * @param {Object[]} programRuleVariables
 * @returns {string}
 */
var getCondition = function getCondition(condition, programRuleVariables) {
  var original = condition;

  try {
    var variables = condition.match(/#\{.*?\}/g);
    if (!variables) return condition;
    variables.filter(function (item, index) {
      return variables.indexOf(item) === index;
    }).forEach(function (variable) {
      var name = variable.substring(2, variable.length - 1);
      var id = programRuleVariables.find(function (ruleVariable) {
        return ruleVariable.name === name;
      }).dataElement.id;
      condition = condition.replace(new RegExp('#{' + name + '}', 'g'), "values['" + id + "']");
    });
  } catch (e) {
    console.warn('Improper condition:', original);
  }

  return condition;
};

exports.getCondition = getCondition;