"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runAssignValueRules = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _runAssignValueAction = require("./runAssignValueAction");

var _getAssignValueRules = require("./getAssignValueRules");

var _getValues = require("./getValues");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var runAssignValueRules = function runAssignValueRules(dataValues, programStageDataElements, _ref) {
  var programRules = _ref.programRules,
      programRuleVariables = _ref.programRuleVariables;
  var values = (0, _getValues.getValues)(dataValues, programStageDataElements);
  var assignValueRules = (0, _getAssignValueRules.getAssignValueRules)(programRules, programRuleVariables);
  assignValueRules.forEach(function (rule) {
    rule.programRuleActions.forEach(function (action) {
      try {
        (0, _runAssignValueAction.runAssignValueAction)(values, _objectSpread({}, action, {
          condition: rule.condition
        }));
      } catch (error) {
        console.warn('Failed to evaluate rule:', rule, error);
      }
    });
  });
  return Object.keys(values).filter(function (id) {
    return values[id] !== '';
  }).map(function (id) {
    return {
      dataElement: id,
      value: values[id]
    };
  });
};

exports.runAssignValueRules = runAssignValueRules;