import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { getCondition } from './getCondition';
const ASSIGN = 'ASSIGN';
/**
 * Returns event program rules, excluding entity program rules,
 * sorted by priority.
 * @param {Object[]} programRules
 * @param {Object[]} programRuleVariables
 * @returns {Object[]}
 */

export const getAssignValueRules = (programRules, programRuleVariables) => programRules.filter(r => r.programRuleActions.find(a => a.dataElement && a.programRuleActionType === ASSIGN)).map(r => _objectSpread({}, r, {
  programRuleActions: r.programRuleActions.filter(({
    programRuleActionType
  }) => programRuleActionType === ASSIGN),
  condition: getCondition(r.condition, programRuleVariables)
})).sort((a, b) => a.priority > b.priority || !a.priority ? 1 : -1);